#include <windows.h>
#include <windef.h>
#include "mdibckgr.h"


BOOL WINAPI DllMain (HINSTANCE hDLL, DWORD dwReason, LPVOID lpReserved)
{
	switch (dwReason)
    {
    case DLL_PROCESS_ATTACH:
    {
     hInstance = hDLL;
	 break;
    }
     case DLL_PROCESS_DETACH:
      break;
    }
return TRUE;
}

LRESULT APIENTRY MDIChildProc (HWND hWnd, UINT uiMsg,
				WPARAM wParam, LRESULT lParam) {
	switch (uiMsg)
	{
	case WM_ERASEBKGND:
		if (hBitmap != NULL)
		{
			HDC hDC = (HDC) wParam;
			HDC hMemDC = (HDC) CreateCompatibleDC(NULL);
			HBITMAP hOldBitmap = NULL;
			HBRUSH hMDIBackgroundBrush = CreateSolidBrush (GetSysColor (COLOR_APPWORKSPACE));
			UINT nWidth, nHeight, nX, nY;
			RECT rect;
			GetClientRect(hWnd, &rect);
			nWidth = rect.right - rect.left;
			nHeight = rect.bottom - rect.top;
			hOldBitmap = (HBITMAP) SelectObject(hMemDC, hBitmap);			
			switch (nState)
			{
				case BMP_TILE: {
					for (nX = 0; nX < nWidth; nX += bm.bmWidth)
						for (nY = 0; nY < nHeight; nY += bm.bmHeight)
							BitBlt(hDC, nX, nY, bm.bmWidth, bm.bmHeight, hMemDC, 0, 0, SRCCOPY);						   
				}
				break;
				case BMP_CENTER: {
					FillRect(hDC, &rect, hMDIBackgroundBrush); //COLOR_APPWORKSPACE
					BitBlt(hDC, (INT)(nWidth - bm.bmWidth)/2, 
								(INT)(nHeight - bm.bmHeight)/2, bm.bmWidth, bm.bmHeight, 
						   hMemDC, 0, 0, SRCCOPY);
				}
				break;
				case BMP_STRECH: {					
					//FillRect(hDC, &rect, hMDIBackgroundBrush); //COLOR_APPWORKSPACE
					StretchBlt(
							hDC,	// handle of destination device context 
							0,	// x-coordinate of upper-left corner of dest. rect. 
							0,	// y-coordinate of upper-left corner of dest. rect. 
							nWidth,	// width of destination rectangle 
							nHeight,	// height of destination rectangle 
							hMemDC,	// handle of source device context 
							0,	// x-coordinate of upper-left corner of source rectangle 
							0,	// y-coordinate of upper-left corner of source rectangle 
							bm.bmWidth,	// width of source rectangle 
							bm.bmHeight,	// height of source rectangle 
							SRCCOPY	 	// raster operation code 
						   );				}
				break;
				default: {
					FillRect(hDC, &rect, hMDIBackgroundBrush);
					BitBlt(hDC, 0, 0, bm.bmWidth, bm.bmHeight, hMemDC, 0, 0, SRCCOPY);						  }
				}			
			SelectObject(hMemDC, hOldBitmap);			
			DeleteDC (hMemDC);
			return 1;
		}
		break;
	case WM_DESTROY:
		if (hBitmap)
		{
			DeleteObject(hBitmap);
			hBitmap = NULL;
			ZeroMemory(&bm, sizeof(BITMAP));
		}
		break;
	case WM_SIZE:
		if (hBitmap)
		{
			RECT rect;
			GetClientRect(hWnd, &rect);
			if ((nState == BMP_CENTER) || (nState == BMP_STRECH))
				InvalidateRect(
					hWnd,	// handle of window with changed update region  
					&rect,	// address of rectangle coordinates 
					1	// erase-background flag 
				   );			
		}
		break;
	}
   return (CallWindowProc (DefMDIWChildProc, hWnd, uiMsg, wParam, lParam));

}/* end MDIChildProc */


INT SetMDIPicture (HWND hwndMDI, LPCTSTR sBitmapName, INT nBitmapState)
{
 RECT rect;
 lstrcpy( (LPSTR) cBitmapName, sBitmapName);
 nState = nBitmapState;
 hWndMDI = hwndMDI;
	
	if (hBitmap) ;
		DeleteObject ((HGDIOBJ) hBitmap);
	
	if (lstrlen(sBitmapName))
		hBitmap = LoadImage (hInstance, (LPSTR) cBitmapName,
				IMAGE_BITMAP, (INT) NULL, (INT) NULL, LR_LOADFROMFILE	);
	if (!hBitmap)
		return 0;
	ZeroMemory(&bm, sizeof(BITMAP));
	GetObject(hBitmap, sizeof(BITMAP), (LPVOID)&bm);

	hWndChild	= FindWindowExA(hwndMDI, (HWND) NULL, (LPSTR)"MDIClient", (LPSTR) NULL);
	
	if  (hWndChild && hBitmap)	{
		if (!DefMDIWChildProc) {
			DefMDIWChildProc = (WNDPROC) GetWindowLong (hWndChild, GWL_WNDPROC);
		}		
		SetWindowLong (hWndChild, GWL_WNDPROC, (LONG) MDIChildProc);
		GetClientRect(hwndMDI, &rect);
		InvalidateRect(hWndChild, &rect, 1);
		return 1;
	}
return 0;
}

